



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《神经网络和深度学习》系列文章三：sigmoid神经元</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《神经网络和深度学习》系列文章三：sigmoid神经元</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 22:41:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>出处： Michael Nielsen的《Neural Network and Deep Leraning》，点击末尾&ldquo;阅读原文&rdquo;即可查看英文原文。</p>
<p>本节译者：哈工大SCIR硕士生 徐伟 (https://github.com/memeda)</p>
<p>声明：我们将在每周一，周四，周日定期连载该书的中文翻译，如需转载请联系wechat_editors@ir.hit.edu.cn，未经授权不得转载。</p>
<p>&ldquo;本文转载自【哈工大SCIR】微信公众号，转载已征得同意。&rdquo;</p>
<hr />
<ol><li><p>使用神经网络识别手写数字</p></li>
<ul><li><p>感知机</p></li>
<li><p><strong>sigmoid神经元</strong></p></li>
<li><p>神经网络的结构</p></li>
<li><p>用简单的网络结构解决手写数字识别</p></li>
<li><p>通过梯度下降法学习参数</p></li>
<li><p>实现我们的网络来分类数字</p></li>
<li><p>关于深度学习</p></li></ul>
<li><p>反向传播算法是如何工作的</p></li>
<li><p>改进神经网络的学习方法</p></li>
<li><p>神经网络能够计算任意函数的视觉证明</p></li>
<li><p>为什么深度神经网络的训练是困难的</p></li>
<li><p>深度学习</p></li></ol>
<h1>sigmoid神经元</h1>
<p>学习算法听起来很好，但问题来了：我们该如何为神经网络量身设计一种学习算法呢？现在假设有一个由感知机构成的网络，我们想让这个网络学习如何去解决一些问题。举例来说，对于一个以手写数字的扫描图像的原始像素数据作为输入的网络，我们想要这个网络去学习<strong>权值（weights）</strong>和<strong>偏移（biases）</strong>以便最终正确地分类这些数字。为了说明学习算法如何才能有效，我们首先假设在网络的一些权值（或偏移）上做一个小的改变。我们期望的结果是，这些在权值上的小改变，将会为网络的输出结果带来相应的改变，且这种改变也必须是轻微的。我们在后面将会看到，满足这样的性质才能使学习变得可能。下面的图片反映了我们想要的结果（当然，图示的网络非常简单，它并不能被用来做手写数字识别）。</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA5E7MZeGrY2fSxa6ECtqsIObkL53p8myeaenzyXldQwrxXrsg9oMnVjQ/0?wx_fmt=png" /></p>
<p>如果满足在权值（或偏移）上的小改变只会引起输出上的小幅变化这一性质，那么以此性质为基础，我们就可以改变权值和偏移来使得网络的表现越来越接近我们预期。例如，假设原始的网络会将一张写着「9」的手写数字图片错误分类为「8」。我们可以尝试找到一个正确的轻微改变权值和偏移的方法，来使得我们网络的输出更接近于正确答案&mdash;&mdash;将该图片分类为「9」。重复这个过程，不断地修改权值和偏移并且产生越来越好的结果。这样我们的网络就开始学习起来了。</p>
<p>但问题在于，当我们的网络包含感知机时情况就与上述描述的不同了。事实上，轻微改变网络中任何一个感知机的权值或偏移有时甚至会导致感知机的输出完全翻转&mdash;&mdash;比如说从0变为1。 这个翻转行为可能以某种非常复杂的方式彻底改变网络中其余部分的行为。所以即使现在「9」被正确分类了，但网络在处理所有其他图片时的行为可能因一些难以控制的方式被彻底改变了。这导致我们逐步改变权值和偏移来使网络行为更加接近预期的学习方法变得很难实施。也许存在一些巧妙的方法来避免这个问题，但对于这种由感知机构成的网络，它的学习算法并不是显而易见的。</p>
<p>由此我们引入一种被称为<strong>S型(sigmoid ，通常我们更习惯使用它的英文称呼，所以本文的其他地方也将使用原始的英文)</strong>神经元的新型人工神经元来解决这个问题。sigmoid神经元与感知机有些相似，但做了一些修改使得我们在轻微改变其权值和偏移时只会引起小幅度的输出变化。这是使由sigmoid神经元构成的网络能够学习的关键因素。</p>
<p>好，接下来就开始介绍本节的主角了。我们将沿用感知机的方式来描述sigmoid神经元。</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA58TggujdXAYaXXLYY1muTaLWKjAeQpClI3FUxV5GVrZhLMM68Uibys3w/0?wx_fmt=png" /></p>
<p>和感知机一样，sigmoid神经元同样有输入，x1,x2,⋯ ， 但不同的是，这些输入值不是只能取0或者1，而是可以取0到1间的任意浮点值。所以，举例来说，0.638&hellip;对于sigmoid神经元就是一个合法输入。同样，sigmoid神经元对每个输入也有相应的权值，w1,w2,&hellip;，以及一个整体的偏移，b 。不过sigmoid神经元的输出不再是0或1，而是&sigma;(w&sdot;x+b) ， 其中的&sigma;被称为<strong>sigmoid函数（sigmoid function）</strong><sup>1</sup>，该函数定义如下：</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA5tCZ0pic75kpT5AHuTSJRh9f3WZTEDM6QjV5sS0EBUc3kvOCYqgcJsiaA/0?wx_fmt=png" /></p>
<p>将上述内容总结一下，更加准确的定义，sigmoid神经元的输出是关于输入x1,x2,&hellip;，权值w1,w2,&hellip;，和偏移b的函数：</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA5NXGcuQ0iazzLlwShjbnAcqYfbOI05mJib5SteCrOd7LO0Uv9D6MO9iaoA/0?wx_fmt=png" /></p>
<p>乍一看去，sigmoid神经元与感知机样子很不同。如果你对它不熟悉，sigmoid函数的代数形式看起来会有些晦涩难懂。但事实上，sigmoid神经元与感知机有非常多相似的地方。sigmoid函数的代数式更多地是展现了其技术细节，而不应是成为理解它的障碍。</p>
<p>为了理解sigmoid神经元与感知机模型的相似性，我们假设z&equiv;w&sdot;x+b是一个很大的正数。这时e<sup>&minus;z</sup>&asymp;0且&sigma;(z)&asymp;1。即是说，当z=w&sdot;x+b是一个很大的正数时，sigmoid神经元的输出接近于1，与感知机类似。另一方面，当z=w&sdot;x+b是一个绝对值很大的负数时，e<sup>&minus;z</sup>&rarr;&infin;且&sigma;(z)&asymp;0。所以当z=w&sdot;x+b是一个绝对值很大的负数时，sigmoid神经元的行为与感知机同样很接近。只有当w&sdot;x+b是一个不太大的数时，其结果与感知机模型有较大的偏差。</p>
<p>我们不禁要问，&sigma;的代数式到底有何含义？我们该如何地理解它呢？事实上，&sigma;的确切形式并不是那么重要&mdash;&mdash;对于我们理解问题，真正重要的是该函数画在坐标轴上的样子。下图表示了它的形状：</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA5LjzXYqo13KCIYAkhMMcHDS2c2balZkSE9axjQKvZ6ibgk0JCKFgTgRw/0?wx_fmt=png" /></p>
<p>这个形状可以认为是下图所示<strong>阶梯函数（step function）</strong>的平滑版本：</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA5rBO3icEacaSxxXo7vAt3tfYKNHAEoWS55OLG1f4A6TZabz4bqmX4ZfQ/0?wx_fmt=png" /></p>
<p>如果把&sigma;函数换成阶梯函数，那么sigmoid神经元就变成了一个感知机，这是因为此时它的输出只随着w&sdot;x+b的正负不同而仅在1或0这两个离散值上变化<sup>2</sup>。所以如前面所言，当使用&sigma;函数时我们就得到了一个平滑的感知机。而且，&sigma;函数的平滑属性才是其关键，不用太在意它的具体代数形式。&sigma;函数的平滑属性意味着当我们在权值和偏移上做出值为&Delta;wj，&Delta;b的轻微改变时，神经元的输出也将只是轻微地变化&Delta;output。事实上，由微积分的知识可知，&Delta;output近似于：</p>
<p><img referrerpolicy="no-referrer"src="http://read.html5.qq.com/image?src=forum&amp;q=5&amp;r=0&amp;imgflag=7&amp;imageUrl=http://mmbiz.qpic.cn/mmbiz/58FUuNaBUjqMx9JdgKWBWnll9ED8iaGA5MZkicTKqTsFbUGTpMM5j0WTZpw3k5zBUia4vQVwZH2iaWRkJrDibh5XlIQ/0?wx_fmt=png" /></p>
<p>其中求和运算是将所有的权值wj相加，&part;output/&part;wj和&part;output/&part;b表示分别求output对wj和b的偏导。如果你看着偏微分不开心，不要惊慌，上面的公式虽然看起来有些复杂，但其实其中的偏微分非常简单（好消息~）：&Delta;output是关于权值和偏移的改变量&Delta;wj和&Delta;b的<strong>线性函数（linear function）</strong>。这种线性属性，使得选择权值和偏移的轻微改变量并使输出按照预期发生小幅度变化成为易事。由上可知，sigmoid神经元不仅与感知机有很多相似的性质，同时也使描述「输出怎样随权值和偏移的改变而改变」这一问题变得简单。</p>
<p>如果真的只是&sigma;的形状起作用而其具体代数形式没有什么用的话，为什么公式(3)要把&sigma;表示为这种特定的形式？事实上，在书的后面部分我们也会偶尔提到一些在输出f(w&sdot;x+b)中使用其它<strong>激活函数（activation function）f(&sdot;)</strong>的神经元。当我们使用其它不同的激活函数时主要改变的是公式(5)中偏微分的具体值。在我们需要计算这些偏微分值之前，使用&sigma;将会简化代数形式，因为指数函数在求微分时有着良好的性质。不管怎样，&sigma;在神经网络工作中是最常被用到的，也是本书中最频繁的激活函数。</p>
<p>我们该如何解释sigmoid神经元的输出呢？显然，感知机和sigmoid神经元一个巨大的不同在于，sigmoid神经元不仅仅只输出0或者1，而是0到1间任意的实数，比如0.173&hellip;，0.689&hellip;都是合法的输出。在一些例子，比如当我们想要把神经网络的输出值作为输入图片的像素点的平均灰度值时，这点很有用处。但有时这个性质也很讨厌。比如在我们想要网络输出关于「输入图片是9」与「输入图片不是9」的预测结果时，显然最简单的方式是如感知机那样输出0或者1。不过在实践中我们可以设置一个约定来解决这个问题，比如说，约定任何输出值大于等于0.5的为「输入图片是9」，而其他小于0.5的输出值表示「输入图片不是9」。当以后使用类似上面的一个约定时，我都会明确地说明，所以这并不会引起任何的困惑。</p>
<blockquote><p>1 顺便提一句，&sigma;有时也被称作逻辑斯谛函数（logistic function），对应的这个新型神经元被称为逻辑斯谛神经元（ogistic neurons）。记住这些术语很有用处，因为很多从事神经网络的人都会使用这些术语。不过本书中我们仍然使用sigmoid这一称呼。</p>
<p>2 事实上，当w&sdot;x+b=0时感知机将输出0，但此时阶梯函数输出值为1。所以严格来讲，我们需要修改阶梯函数在0这个点的值。大家明白这点就好。</p></blockquote>
<h1>练习</h1>
<hr />
<ul><li><p><strong>sigmoid神经元模拟感知机（第一部分）</strong>对一个由感知机组成的神经网络，假设将其中所有的权值和偏移都乘上一个正常数，c&gt;0 ， 证明网络的行为并不会发生改变。</p></li>
<li><p><strong>sigmoid神经元模拟感知机（第二部分）</strong>假设与上述问题相同的初始条件&mdash;&mdash;由感知机构成的神经网络。假设感知机的所有输入都已经被选定。我们并不需要实际的值，只需要保证输入固定。假定对网络中任意感知机的输入x都满足w&sdot;x+b&ne;0。现在将网络中所有的感知机都替换为sigmoid神经元，然后将所有的权值和偏移都乘上一个正常数c&gt;0 。 证明在极限情况即c&rarr;&infin;下，这个由sigmoid神经元构成的网络与感知机构成的网络行为相同。同时想想当w&sdot;x+b=0时为何不是如此？</p></li></ul>
<p>下一节我们将介绍&ldquo;神经网络的结构&rdquo;，敬请关注！</p>
<hr />
<ul><li><p>&ldquo;哈工大SCIR&rdquo;公众号</p></li>
<li><p>编辑部：郭江，李家琦，徐俊，李忠阳，俞霖霖</p></li>
<li><p>本期编辑：俞霖霖</p></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zzn5v8.html">亲子之间，在于看懂，无关耐心zz</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pr5jzq.html">android 模拟器</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954kozq.html">python学习笔记4（对象／引用；多范式&semi; 上下文管理器）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wwo5xq.html">xampp搭建服务器环境、html5新的input类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xydvn9.html">The constness of a method should makes sense from outside the object</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdep1n09.html">Color Map的生成方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xv7k9.html">Linux主机在LNMP环境中同时运行多个PHP版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xly39.html">oracle 对象上锁，不能插入或删除情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj1pnj8.html">SAE微信公众号PHP SDK， token一直验证失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2joz9.html">【学习笔记】js下拉刷新、上拉加载 mescroll框架的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1ldvjq.html">Wpf DataGridCheckBoxColumn 问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kozmz9.html">剑指Offer-删除链表中重复的结点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jd7j0q.html">&lbrack;特征工程&rsqb;-------使用sklearn做单机特征工程&lbrack;转载&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwvoez8.html">Apache的配置详解 带图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjyeze9.html">SpringBoot------Maven Clean报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jogn0q.html">Google advertiser api开发概述&mdash;&mdash;部分失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/9530x3v8.html">Springboot 线程池配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p4eo0q.html">druid&period;io本地集群搭建 &sol; 扩展集群搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/953w1jm8.html">Python oct&lpar;&rpar; 函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjvwozq.html">ora-28056错误解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwder438.html">Linux网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mwdpgq.html">小笔记&lpar;一&rpar;：ajax传递数组及将ajax返回数据赋值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1k06g8.html">简谈Comparable和Comparator区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1lljj9.html">Discuz帖子列表页无法ajax加载下一页问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mww21q.html">The Unified Modeling Language&lpar;UML&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xll209.html">bzoj 3572&colon; &lbrack;Hnoi2014&rsqb;世界树 虚树 &amp;amp&semi;&amp;amp&semi; AC500</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xvv2m8.html">bzoj 1200&colon; &lbrack;HNOI2005&rsqb;木梳 DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnv4grq.html">视频硬解api介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnv7grq.html">LREM key count value</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjy4wy9.html">IP处理函数inet&lowbar;aton&lpar;&rpar;和inet&lowbar;ntoa&lpar;&rpar;，inet&lowbar;pton&comma;inet&lowbar;ntop</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
